diff -ur linux-2.4.27-orig/arch/sparc/Makefile  linux-2.4.27/arch/sparc/Makefile
--- linux-2.4.27-orig/arch/sparc/Makefile	2004-08-08 00:26:04.000000000 +0100
+++ linux-2.4.27/arch/sparc/Makefile	2004-09-09 17:13:26.000000000 +0100
@@ -45,6 +45,7 @@
 	$(TOPDIR)/arch/sparc/lib/lib.a
 
 # This one has to come last
+_dir_arch/sparc/boot : $(patsubst %, _dir_%, $(SUBDIRS))
 SUBDIRS += arch/sparc/boot
 CORE_FILES_NO_BTFIX := $(CORE_FILES)
 CORE_FILES += arch/sparc/boot/btfix.o

diff -ur linux-2.4.27-orig/arch/sparc/boot/Makefile linux-2.4.27/arch/sparc/boot/Makefile
--- linux-2.4.27-orig/arch/sparc/boot/Makefile	2002-08-03 01:39:43.000000000 +0100
+++ linux-2.4.27/arch/sparc/boot/Makefile	2004-09-09 17:25:27.000000000 +0100
@@ -26,11 +26,14 @@
 BTLIBS := $(CORE_FILES_NO_BTFIX) $(FILESYSTEMS) \
 	$(DRIVERS) $(NETWORKS)
 
-# I wanted to make this depend upon BTOBJS so that a parallel
-# build would work, but this fails because $(HEAD) cannot work
-# properly as it will cause head.o to be built with the implicit
-# rules not the ones in kernel/Makefile.  Someone please fix. --DaveM
-vmlinux.o: dummy
+GENFILES := include/linux/version.h include/linux/compile.h $(foreach dirname, $(CORE_FILES_NO_BTFIX), _dir_$(dir $(dirname)))
+.PHONY : $(GENFILES)
+GENFILES += $(BTOBJS)
+
+$(GENFILES):
+		$(MAKE) -C $(TOPDIR) $@
+
+vmlinux.o: $(GENFILES)
 	$(LD) -r $(patsubst %,$(TOPDIR)/%,$(BTOBJS)) \
 		--start-group \
 		$(patsubst %,$(TOPDIR)/%,$(BTLIBS)) \
